//
// Inclusion of standard header file
//
#include <cmath>
#include <limits>

//
// Inclusion of local header file
//
#include "islibdef.hpp"
#include "islibfunc.hpp"
#include "sigmoid.hpp"

namespace islib
  {
    //
    // Definition of funcion
    //
    double
      sigmoid
      (
        double const x
      )
      {
        double y;

        class local
          {
          public:
            local
              (
                double const &parameter_local_y
              ):
              local_y ( parameter_local_y )
              {
              }

            ~local
              (
              )
              throw
              (
              )
              {
                islib_assert_with_message ( is_greater_than_or_equals_to ( this->local_y, 0.0, std::numeric_limits < double >::epsilon () ) && is_less_than_or_equals_to ( this->local_y, 1.0, std::numeric_limits < double >::epsilon () ), islib::sigmoid );
              }

          private:
            double const &local_y;
          }
        a_local ( y );

        y = 1.0 / ( 1.0 + std::pow ( e, -x ) );

        return y;
      }
  }

//
// End of file
//
